#include "uart.h"
/*
Function: uart_send_character
    
*/
void uart_send_character (unsigned char character)
{
	// Loop until the TRMT bit is set ()
	while (txsta.TRMT == 0);

	txreg = character;

	// Loop until the stuff has been transmitted.
	while(txsta.TRMT);
}

void uart_send_string (unsigned char *string)
{
	unsigned char *p = string;

	while (*p != '\0') { uart_send_character(*p++); }
}

void uart_enable (void)
{
	txsta.TXEN = 1;
	rcsta.SPEN = 1;
	txsta.SYNC = 0;
	txsta.BRGH = 0;
	baudcon.BRG16 = 0;
	trisc.6 = 1;
	trisc.7 = 1;

	spbrgh = 0;
	spbrg = 64;
}

void uart_disable (void)
{
	rcsta.SPEN = 0;
	trisc.6 = 1;
	trisc.7 = 1;
}