; MPLAB Assembler file for TimeIt display operation at 40 Mhz operation.
; Copyright Martin Persson System & Design 2008
#include p18f2515.inc

; Start by configuring the I/O ports for digital I/O.
	movf DDRA, 11010000b
	movf DDRC, 11111100b

; First wait for the display to start up properly, call delay routine.
	movwf .244
	call delay

; Start initialization of display according to HD44780 specifications.
	movf LATA, 1101000b
	call send_command


send_command
	bsf LATA, 2		; Pull enable line high.
	movwf .244
	call delay		; Delay for 2 microsenconds.
	bcf LATA, 2		; Pull enable line low.
	movwf .244
	call delay		; Delay for 2 microsenconds.

; Subroutine: delay_us
; ====================
; A basic delay subroutine for the microsecond range.
delay_us
	
; Subrutine: delay_ms
; ===================
; Basic delay subroutine for the millisecond range.
delay_ms


