#include "menu.h"

static const menu_item_t menu_items[] = {
	{ MENU_STRING_MAIN, 6, MENU_STRING_SPRINT, 5, MENU_ITEM_ARROW_BIT},
	{ MENU_STRING_MAIN, 6, MENU_STRING_JUMP, 5, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_ENDURANCE, 5, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_RESULTS, 5, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_SETUP, 5, MENU_ITEM_ARROW_BIT },

	{ MENU_STRING_MAIN, 6, MENU_STRING_SENSORSTART, 2, MENU_ITEM_ARROW_BIT }, 
	{ MENU_STRING_MAIN, 6, MENU_STRING_SIGNALSTART, 2, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_RANDOMSTART, 2, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_SWITCHSTART, 2, MENU_ITEM_ARROW_BIT },
};


void menu_process (keys_t key)
{
	switch (menu_state)
	{
	case MENU_STATE_SPRINT:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_JUMP;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_SETUP;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_SPRINT;
			break;

		default:
			break;
		};
		break;

	case MENU_STATE_SPRINT_SENSOR:
		break;

	case MENU_STATE_SPRINT_SIGNAL:
		break;

	case MENU_STATE_SPRINT_RANDOM:
		break;
	case MENU_STATE_SPRINT_SWITCH:
		break;

	case MENU_STATE_JUMP:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_ENDURANCE;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_SPRINT;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_JUMP;
			break;

		default:
			break;
		};
		break;
	case MENU_STATE_JUMP_SINGLE:
		break;
	case MENU_STATE_JUMP_MULTIPLE:
		break;

	case MENU_STATE_ENDURANCE:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_RESULTS;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_JUMP;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_ENDURANCE;
			break;

		default:
			break;
		};
		break;
	case MENU_STATE_ENDURANCE_BEEP:
		break;
	case MENU_STATE_ENDURANCE_MULTI:
		break;
	case MENU_STATE_RESULTS:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_SETUP;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_ENDURANCE;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_RESULTS;
			break;

		default:
			break;
		};
		break;
		break;
	case MENU_STATE_RESULTS_SPRINT:
		break;
	case MENU_STATE_RESULTS_JUMP:
		break;
	case MENU_STATE_RESULTS_ENDURANCE:
		break;
	case MENU_STATE_SETUP:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_SPRINT;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_ENDURANCE;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_SETUP;
			break;

		default:
			break;
		};
		break;
	case MENU_STATE_SETUP_DATE:
		break;
	case MENU_STATE_SETUP_MEMORY:
		break;
	case MENU_STATE_SETUP_MEMORY_STATUS:
		break;
	case MENU_STATE_SETUP_MEMORY_CLEARPLAYER:
		break;
	case MENU_STATE_SETUP_MEMORY_CLEAR:
		break;
	case MENU_STATE_SETUP_SOFTWARE:
		break;
	};
}

void menu_draw (void)
{
	menu_item_t *item;

	display_4bit_clear();

	item = &menu_items[menu_state];

	// Draw the two menu strings first.
	display_4bit_set_position(item->string1_position, 0);
	display_4bit_write_string(menu_strings[item->string1]);
	display_4bit_set_position(item->string2_position, 1);
	display_4bit_write_string(menu_strings[item->string2]);

	// If flagged, draw the arrow markers as well.
	if (item->flags & MENU_ITEM_ARROW_BIT) {
		display_4bit_set_position(0, 0);
		display_4bit_write_character('<');
		display_4bit_set_position(0, 15);
		display_4bit_write_character('>');
	}
}
