//#include "display_4bit.h"
#include "keypad.h"
/* #include "menu.h" */

#pragma CLOCK_FREQ 40000000

#define MENU_STRING_MAIN			1
#define MENU_STRING_SPRINT			2
#define MENU_STRING_JUMP			3
#define MENU_STRING_ENDURANCE		4
#define MENU_STRING_SENSORSTART		5	
#define MENU_STRING_SIGNALSTART		6
#define MENU_STRING_RANDOMSTART		7
#define MENU_STRING_SWITCHSTART		8
#define MENU_STRING_NUMBEROF		9

const char *menu_strings[] = {
	"MAIN",
	"SPRINT",
	"JUMP",
	"ENDURANCE",
	"SENSOR START",
	"SIGNAL START",
	"RANDOM START",
	"SWITCH START",
	"NUMBER OF"
};

typedef enum menu_states
{
	MENU_STATE_SPRINT,
	MENU_STATE_SPRINT_SENSOR,
	MENU_STATE_SPRINT_SIGNAL,
	MENU_STATE_SPRINT_RANDOM,
	MENU_STATE_SPRINT_SWITCH,
	MENU_STATE_JUMP,
	MENU_STATE_JUMP_SINGLE,
	MENU_STATE_JUMP_MULTIPLE,
	MENU_STATE_ENDURANCE,
	MENU_STATE_ENDURANCE_BEEP,
	MENU_STATE_ENDURANCE_MULTI,
	MENU_STATE_RESULTS,
	MENU_STATE_RESULTS_SPRINT,
	MENU_STATE_RESULTS_JUMP,
	MENU_STATE_RESULTS_ENDURANCE,
	MENU_STATE_SETUP,
	MENU_STATE_SETUP_DATE,
	MENU_STATE_SETUP_MEMORY,
	MENU_STATE_SETUP_MEMORY_STATUS,
	MENU_STATE_SETUP_MEMORY_CLEARPLAYER,
	MENU_STATE_SETUP_MEMORY_CLEAR,
	MENU_STATE_SETUP_SOFTWARE
} menu_states_t;

static menu_states_t menu_state = MENU_STATE_SPRINT;

void menu_process (keys_t key);
void menu_draw (void);


typedef struct menu_item
{
	char string1;
	unsigned char string1_position;
	char string2;
	unsigned char string2_position;
	char flags;
} menu_item_t;

//#define MENU_ITEM_ARROW_BIT	0x01
//#define MENU_ITEM_INPUT_BIT 0x02

unsigned char mytable[] = { 0, 1, 0, 1 };

/*
static const menu_item_t menu_items[] = {
	{ MENU_STRING_MAIN, 6, MENU_STRING_SPRINT, 5, MENU_ITEM_ARROW_BIT},
	{ MENU_STRING_MAIN, 6, MENU_STRING_JUMP, 5, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_ENDURANCE, 5, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_RESULTS, 5, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_SETUP, 5, MENU_ITEM_ARROW_BIT },

	{ MENU_STRING_MAIN, 6, MENU_STRING_SENSORSTART, 2, MENU_ITEM_ARROW_BIT }, 
	{ MENU_STRING_MAIN, 6, MENU_STRING_SIGNALSTART, 2, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_RANDOMSTART, 2, MENU_ITEM_ARROW_BIT },
	{ MENU_STRING_MAIN, 6, MENU_STRING_SWITCHSTART, 2, MENU_ITEM_ARROW_BIT },
};
*/

void menu_process (keys_t key)
{
	switch (menu_state)
	{
	case MENU_STATE_SPRINT:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_JUMP;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_SETUP;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_SPRINT;
			break;

		default:
			break;
		};
		break;

	case MENU_STATE_SPRINT_SENSOR:
		break;

	case MENU_STATE_SPRINT_SIGNAL:
		break;

	case MENU_STATE_SPRINT_RANDOM:
		break;
	case MENU_STATE_SPRINT_SWITCH:
		break;

	case MENU_STATE_JUMP:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_ENDURANCE;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_SPRINT;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_JUMP;
			break;

		default:
			break;
		};
		break;
	case MENU_STATE_JUMP_SINGLE:
		break;
	case MENU_STATE_JUMP_MULTIPLE:
		break;

	case MENU_STATE_ENDURANCE:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_RESULTS;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_JUMP;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_ENDURANCE;
			break;

		default:
			break;
		};
		break;
	case MENU_STATE_ENDURANCE_BEEP:
		break;
	case MENU_STATE_ENDURANCE_MULTI:
		break;
	case MENU_STATE_RESULTS:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_SETUP;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_ENDURANCE;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_RESULTS;
			break;

		default:
			break;
		};
		break;
		break;
	case MENU_STATE_RESULTS_SPRINT:
		break;
	case MENU_STATE_RESULTS_JUMP:
		break;
	case MENU_STATE_RESULTS_ENDURANCE:
		break;
	case MENU_STATE_SETUP:
		switch (key)
		{
		case KEY_NEXT:
			menu_state = MENU_STATE_SPRINT;
			break;
		
		case KEY_PREV:
			menu_state = MENU_STATE_ENDURANCE;
			break;

		case KEY_OK:
			menu_state = MENU_STATE_SETUP;
			break;

		default:
			break;
		};
		break;
	case MENU_STATE_SETUP_DATE:
		break;
	case MENU_STATE_SETUP_MEMORY:
		break;
	case MENU_STATE_SETUP_MEMORY_STATUS:
		break;
	case MENU_STATE_SETUP_MEMORY_CLEARPLAYER:
		break;
	case MENU_STATE_SETUP_MEMORY_CLEAR:
		break;
	case MENU_STATE_SETUP_SOFTWARE:
		break;
	};
}

void menu_draw (void)
{
	menu_item_t *item;

	display_4bit_clear();

	item = &menu_items[menu_state];

	// Draw the two menu strings first.
	display_4bit_set_position(item->string1_position, 0);
	display_4bit_write_string(menu_strings[item->string1]);
	display_4bit_set_position(item->string2_position, 1);
	display_4bit_write_string(menu_strings[item->string2]);

	// If flagged, draw the arrow markers as well.
	if (item->flags & MENU_ITEM_ARROW_BIT) {
		display_4bit_set_position(0, 0);
		display_4bit_write_character('<');
		display_4bit_set_position(0, 15);
		display_4bit_write_character('>');
	}
}


void main (void)
{
	keys_t key;

	delay_ms(200);
	delay_ms(200);

	// Configure I/O pins.
	DISPLAY_D4_DDR = 0;
	DISPLAY_D5_DDR = 0;
	DISPLAY_D6_DDR = 0;
	DISPLAY_D7_DDR = 0;

	DISPLAY_E_DDR = 0;
	DISPLAY_RS_DDR = 0;
	DISPLAY_RW_DDR = 0;
	
	DISPLAY_RS = 0;
	DISPLAY_RW = 0;
	DISPLAY_E = 0;

	delay_us(2);

	display_4bit_init();

	menu_draw();

	while(1) {
		if ((key = keypad_scan()) != KEY_NONE) {
			menu_process(key);
			menu_draw();
		}
	}
}

