#include "keypad.h"

keys_t keypad_scan (void)
{
	#ifdef DEBUG_KEYPAD
	unsigned char buffer[32];
	#endif

	unsigned char counter, row, column;
	static const unsigned char output_mask = 0x0F;
	static const unsigned char input_mask = 0xF8;
	
	for (column = 0x01; column < 0x10; column = column << 1) {

		lata &= 0xF0;

		lata |= (~column);
	
		delay_us(100); // Wait while things stabilize a bit.

		row = portb; // Read the input.

		// The condition for which a button is considered pressed is
		// that the column bit (RAx) is low and that the corresponding
		// row bit (RBx) is also low.
		if (!test_bit(row, ROW_0)) {

			switch (column)
			{
			case 0x01:
				return KEY_PREV;
				break;

			case 0x02:
				return KEY_3;
				break;

			case 0x04:
				return KEY_2;
				break;

			case 0x08:
				return KEY_1;
				break;
			}

		} else if (!test_bit(row, ROW_1)) {

			switch (column)
			{
			case 0x01:
				return KEY_POP_DEC;
				break;

			case 0x02:
				return KEY_6;
				break;

			case 0x04:
				return KEY_5;
				break;

			case 0x08:
				return KEY_4;
				break;
			}

		} else if (!test_bit(row, ROW_2)) {

			switch (column)
			{
			case 0x01:
				return KEY_OK;
				break;

			case 0x02:
				return KEY_9;
				break;

			case 0x04:
				return KEY_8;
				break;

			case 0x08:
				return KEY_7;
				break;
			}

		} else if (!test_bit(row, ROW_3)) {
			switch (column)
			{
			case 0x01:
				return KEY_SUB_INC;
				break;
			}

		} else if (!test_bit(row, ROW_4)) {
			switch (column)
			{
			case 0x01:
				return KEY_NEXT;
				break;

			case 0x02:
				return KEY_PRINT;
				break;

			case 0x04:
				return KEY_0;
				break;

			case 0x08:
				return KEY_CANCEL;
				break;
			}
		}
	}

	return KEY_NONE;
}