#ifndef TIMEIT_H
#define TIMEIT_H

typedef enum timeit_test_types
{
	TIMEIT_TEST_TYPE_SPRINT_SENSOR,
	TIMEIT_TEST_TYPE_SPRINT_SWITCH,
	TIMEIT_TEST_TYPE_SPRINT_RANDOM,
	TIMEIT_TEST_TYPE_SPRINT_SIGNAL,
	TIMEIT_TEST_TYPE_SPRINT_MULTIPLE,
	TIMEIT_TEST_TYPE_JUMP_SINGLE,
	TIMEIT_TEST_TYPE_JUMP_MULTIPLE
} timeit_test_types_t;

typedef struct timeit_results
{
	int trtp_version;
	int num_records;
	timeit_record_t *records;
} timeit_results_t;

typedef struct timeit_date
{
	int year;
	int month;
	int day;
	int hours;
	int minutes;
	int seconds;
} timeit_date_t;

typedef struct timeit_time
{
	int minutes;
	int seconds;
	int hundreds;
} timeit_time_t;

typedef struct timeit_record
{
	int player_id;
	int test_id;
	
	timeit_test_types_t type;
} timreit_record_t;

int timeit_decode (timeit_results_t *results, const char *src, int *src_len);

#endif
