#include "timeitdownloader_resources.h"

#include "common.h"

#include <commctrl.h>

#include <string>
#include <iostream>
#include <fstream>
#include <cstdio>

#include <vector>
#include <algorithm>

#define PANEL_HEIGHT 30

using namespace std;

static const char *WINDOW_CLASSNAME = "TimeitDownloaderWindowClass";

LRESULT WINAPI WndProc (HWND window, UINT msg, WPARAM wParam, LPARAM lParam);
bool init (HWND window);

// Globals
HWND window;
FILE *log;
void createWindow (HWND window);

int WINAPI WinMain (HINSTANCE instance, HINSTANCE prevInstance,
	LPSTR cmdline, int cmdshow)
{
	WNDCLASS wc;
	MSG msg;
	INITCOMMONCONTROLSEX cces;
	
	static double acc = 0.0;

	if ((log = fopen("logfile.txt", "w")) == 0) {
		MessageBox(0, "Suck my brows!", 0, MB_OK);
	}

	ZeroMemory(&wc, sizeof(WNDCLASS));
	wc.style = CS_DBLCLKS;
	wc.lpfnWndProc = WndProc;
	wc.hInstance = instance;
	wc.hIcon = LoadIcon(instance, MAKEINTRESOURCE(ID_ICON_MAIN));
	wc.hCursor = LoadCursor(0, IDC_ARROW);
	wc.hbrBackground = (HBRUSH) (COLOR_WINDOW + 1);
	wc.lpszClassName = WINDOW_CLASSNAME;
	
	fprintf(log, "Registering window class\n");
	if (!RegisterClass(&wc)) {
		MessageBox(0, "Unable to register the window class.\n"
			"Please contact support.", 0, MB_OK | MB_ICONERROR);
		return 1;
	}

	fprintf(log, "init common controls\n");

	cces.dwSize = sizeof(cces);
	cces.dwICC = ICC_WIN95_CLASSES | ICC_BAR_CLASSES;
	if (!InitCommonControlsEx(&cces)) {
		MessageBox(0, "Unable to initialize the common controls.\n"
			"Please contact support.", 0, MB_OK | MB_ICONERROR);
		UnregisterClass(WINDOW_CLASSNAME, wc.hInstance);
		return 1;
	}

	fprintf(stdout, "Debug console opened.\n");
	printf("Creating window.\n");	
	window = CreateWindowEx(0, WINDOW_CLASSNAME, "TimeIt Downloader",
		WS_OVERLAPPEDWINDOW | WS_CLIPSIBLINGS | WS_CLIPCHILDREN,
		CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		0, 0, instance, 0);

	if (window == 0) {
		MessageBox(0, "Unable to create main window.\n"
			"Please contact support.", 0, MB_OK | MB_ICONERROR);
	} else {
			fprintf(log, "Showing window.\n");	
			ShowWindow(window, SW_SHOWDEFAULT);
			UpdateWindow(window);

			fprintf(log, "Entering message loop.\n");
			ZeroMemory(&msg, sizeof(msg));
			int ret;
			while ((ret = GetMessage(&msg, 0, 0, 0)) != 0) {
				if (ret == -1) {
					fprintf(log, "An error occured.\n");
				}
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
	}
	fprintf(log, "Unregistering class\n");
	UnregisterClass(WINDOW_CLASSNAME, wc.hInstance);

	return 0;
}

LRESULT WINAPI WndProc (HWND window, UINT msg, WPARAM wParam, LPARAM lParam)
{
	LRESULT ret = 0;
	unsigned char key;
	HDC drawing_context;

	drawing_context = GetDC(window);

	switch (msg)
	{
	case WM_CREATE:
		createWindow(window);
		break;

	case WM_PAINT:
		break;

	case WM_KEYDOWN:
		key = (unsigned char) wParam;
		break;

	case WM_KEYUP:
		key = (unsigned char) wParam;
		break;

	case WM_MOUSEMOVE:
		POINTS cursorPosition;
		cursorPosition = MAKEPOINTS(lParam);
		break;

	case WM_SIZE:
		break;

	case WM_CLOSE:
		DestroyWindow(window);
		break;

	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	
	default:
		ret = DefWindowProc(window, msg, wParam, lParam);
		break;
	};
	
	return ret;
}

void createWindow (HWND window)
{
	HWND temp;
	HINSTANCE instance;
	RECT client_rect;

	if ((instance = (HINSTANCE) GetWindowLong(window, GWL_HINSTANCE)) == 0) {
		return;
	}

	GetClientRect(window, &client_rect);
/*
	if ((temp = CreateWindow("BUTTON", "Redraw", WS_CHILD | WS_VISIBLE,
		client_rect.right - 80, client_rect.bottom - PANEL_HEIGHT, 80, 28,
		window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}

	if ((temp = CreateWindow("STATIC", "Min. value", WS_CHILD | WS_VISIBLE,
		0, client_rect.bottom - PANEL_HEIGHT, 50, 18, window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}

	if ((temp = CreateWindow("EDIT", "0", WS_CHILD | WS_VISIBLE,
		60, client_rect.bottom - PANEL_HEIGHT, 32, 18, window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}

	if ((temp = CreateWindow("STATIC", "Max. value", WS_CHILD | WS_VISIBLE,
		0, client_rect.bottom - PANEL_HEIGHT, 32, 18, window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}

	if ((temp = CreateWindow("EDIT", "250", WS_CHILD | WS_VISIBLE,
		0, client_rect.bottom - PANEL_HEIGHT, 32, 18, window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}

	if ((temp = CreateWindow("STATIC", "Values", WS_CHILD | WS_VISIBLE,
		0, client_rect.bottom - PANEL_HEIGHT, 32, 18, window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}

	if ((temp = CreateWindow("EDIT", "512", WS_CHILD | WS_VISIBLE,
		0, client_rect.bottom - 20, 32, 18, window, 0, instance, 0)) == 0) {
		MessageBox(0, "Error creating buttons.", 0, MB_OK);
	}
	*/
}
